/***************************************************************
  MantisChess.cpp : 

  Ȩ(C)  ³

  һGNUͨù
  ֤޸ĺ·һ򡣻֤ĵڶ棬
  (ѡ)κθµİ汾

  һĿϣãûκεûʺ
  ĿĵĵϸGNUͨù֤
  
  ӦѾͳһյһGNUͨù֤ĸ
  ûУдŸ

  The Free Software FoundationInc675 Mass Ave Cambridge
  MAO2139USA

  ʹñʱʲô飬µַȡ
  ϵ

              http://thecct.51.net

  Email

              stove@eyou.com
              thecct@163.com

------------------------------------------------------------------
  MantisChess.cpp : program entrance

  Copyright (C)  Chen Chengtao, China
  
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
  
  If you have any question about this software please visit my hompage:

              http://thecct.51.net

  or E_mail to:

              stove@eyou.com
              thecct@163.com

******************************************************************/


#include "StdAfx.h"
#include "resource.h"
#include "MantisChessDef.h"
#include "MantisChessDraw.h"
#include "MantisChessStd.h"
#include "MantisChessThink.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

//----------------------------
void OnCreate(HWND hWnd);
void Reset();
void ShowRect(HDC hdc,LPRECT prect);
void ShowPoint(HDC hdc,POINT point);
void Think(HWND hWnd);
BOOL Go(HWND hWnd,int man,POINT targetpoint);
void OnMouseMove(POINT point);
void OnLButtonDown(HWND hWnd,POINT point);
BOOL FaceToPoint(POINT &point);
void OnBack(HWND hWnd);

//--------------------------------------
static  POINT g_pointChessman[32];	//
static  int g_iChessmanMap[11][12];	//λ״̬
static  int g_iSide;				//ֵķ
static  HCURSOR g_hCurCantGo;		//Եʱʾ
static  HCURSOR g_hCurHand;			//Եʱʾ
static  HCURSOR g_hCurThinking;		//ʱʾ
static 	HICON g_hIconChessman[14];	//ӵͼ
static 	HICON g_hIconBox;			//ָʾһ߷Ŀ
static 	HICON g_hIconSelect;		//ָʾѡӵĿ
static 	HICON g_hIconCanMove;		//ָʾɵλ
static 	HICON g_hIconAttack;		//ָʾ
static 	HDC g_hdcChessboard;		//̵豸
static 	HBITMAP g_hbmpChessboard;	//̵λͼ
static 	POINT g_pointBoxFrom;		//һԭʼλ
static 	POINT g_pointBoxTo;			//һĿλ
static 	int g_iChessmanSelect;		//ѡ
static 	int g_iComputerSide;		//Եɫ
static  BOOL g_bEndGame;			//Ϸ־
static  BOOL g_bCanMove[11][12];	//

static	struct	MOVEHISTORY	g_MoveHistory;
//--------------------------------------

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_MANTIS, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_MANTIS);
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= NULL;
	wcex.lpszMenuName	= (LPCSTR)IDC_MANTIS;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU,,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	RECT rect;
	TCHAR szHello[MAX_LOADSTRING];
	LoadString(hInst, IDS_HELLO, szHello, MAX_LOADSTRING);
	POINT point;
	switch (message) 
	{
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				case IDM_NEW_BLACK:
					Reset();
					g_iComputerSide=RED;
					rect.left=0;
					rect.top=0;
					rect.right=XBW;
					rect.bottom=YBW;
					hdc=GetDC(hWnd);
					ShowRect(hdc,&rect);
					SetCursor(g_hCurThinking);
					Think(hWnd);
					SetCursor(g_hCurCantGo);
					break;
				case IDM_NEW_RED:
					Reset();
					g_iComputerSide=BLACK;
					rect.left=0;
					rect.top=0;
					rect.right=XBW;
					rect.bottom=YBW;
					hdc=GetDC(hWnd);
					ShowRect(hdc,&rect);
					break;
				case IDM_BACK:
					OnBack(hWnd);
					break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rect;
			GetClientRect(hWnd, &rect);
			ShowRect(hdc,&rect);	
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			DeleteObject(g_hbmpChessboard);
			DeleteDC(g_hdcChessboard);
			PostQuitMessage(0);
			break;
		case WM_CREATE:
			OnCreate(hWnd);
			break;
		case WM_LBUTTONDOWN:
			point.x=LOWORD(lParam);
			point.y=HIWORD(lParam);
			OnLButtonDown(hWnd,point);
			break;
		case WM_MOUSEMOVE:
			point.x=LOWORD(lParam);
			point.y=HIWORD(lParam);
			OnMouseMove(point);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}


/******************************************************************
OnCreate:		WM_CREATE ϢӦʱгʼ

:
hWnd:			ھ

ֵ:			
******************************************************************/
void OnCreate(HWND hWnd)
{
	g_hCurHand=LoadCursor(hInst,MAKEINTRESOURCE(IDC_HAND));
	g_hCurThinking=LoadCursor(hInst,MAKEINTRESOURCE(IDC_THINKING));
	g_hCurCantGo=LoadCursor(hInst,MAKEINTRESOURCE(IDC_CANTGO));
	g_hIconChessman[RED_K]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_K));
	g_hIconChessman[RED_S]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_S));
	g_hIconChessman[RED_X]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_X));
	g_hIconChessman[RED_M]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_M));
	g_hIconChessman[RED_J]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_J));
	g_hIconChessman[RED_P]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_P));
	g_hIconChessman[RED_B]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_R_B));

	g_hIconChessman[BLACK_K]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_K));
	g_hIconChessman[BLACK_S]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_S));
	g_hIconChessman[BLACK_X]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_X));
	g_hIconChessman[BLACK_M]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_M));
	g_hIconChessman[BLACK_J]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_J));
	g_hIconChessman[BLACK_P]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_P));
	g_hIconChessman[BLACK_B]=LoadIcon(hInst,MAKEINTRESOURCE(IDI_B_B));
	g_hIconBox=LoadIcon(hInst,MAKEINTRESOURCE(IDI_BOX));
	g_hIconSelect=LoadIcon(hInst,MAKEINTRESOURCE(IDI_SELECT));
	g_hIconCanMove=LoadIcon(hInst,MAKEINTRESOURCE(IDI_CANMOVE));
	g_hIconAttack=LoadIcon(hInst,MAKEINTRESOURCE(IDI_ATTACK));

	Reset();
	HDC hdc=GetDC(hWnd);
	g_hdcChessboard=CreateCompatibleDC(hdc);
	g_hbmpChessboard=CreateCompatibleBitmap(hdc,XBW,YBW);
	SelectObject(g_hdcChessboard,g_hbmpChessboard);
	int nCurTime=(int)::GetTickCount();
	MakeBoard(g_hdcChessboard,RGB(180,180+nCurTime%30,160));
	RECT rect={0,0,XBW,YBW};
	AdjustWindowRect(&rect,WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU,TRUE);
	POINT lefttop;
	lefttop.x=(GetSystemMetrics(SM_CXSCREEN)-(rect.right-rect.left))/2;
	lefttop.y=(GetSystemMetrics(SM_CYSCREEN)-(rect.bottom-rect.top))/2;
	rect.left+=lefttop.x;
	rect.right+=lefttop.x;
	rect.top+=lefttop.y;
	rect.bottom+=lefttop.y;
	MoveWindow(hWnd,rect.left,rect.top,rect.right-rect.left,rect.bottom-rect.top,TRUE);
}

/******************************************************************
Reset:			ݻָΪʼֵ

:			

ֵ:			
******************************************************************/
void Reset()
{
	int i,j;

	g_pointChessman[0].x=5;g_pointChessman[0].y=10;	//˧
	g_pointChessman[1].x=4;g_pointChessman[1].y=10;	//ʿ
	g_pointChessman[2].x=6;g_pointChessman[2].y=10;	
	g_pointChessman[3].x=3;g_pointChessman[3].y=10;	//
	g_pointChessman[4].x=7;g_pointChessman[4].y=10;
	g_pointChessman[5].x=2;g_pointChessman[5].y=10;	//
	g_pointChessman[6].x=8;g_pointChessman[6].y=10;
	g_pointChessman[7].x=1;g_pointChessman[7].y=10;	//
	g_pointChessman[8].x=9;g_pointChessman[8].y=10;
	g_pointChessman[9].x=2;g_pointChessman[9].y=8;	//
	g_pointChessman[10].x=8;g_pointChessman[10].y=8;
	g_pointChessman[11].x=1;g_pointChessman[11].y=7;//
	g_pointChessman[12].x=3;g_pointChessman[12].y=7;
	g_pointChessman[13].x=5;g_pointChessman[13].y=7;
	g_pointChessman[14].x=7;g_pointChessman[14].y=7;
	g_pointChessman[15].x=9;g_pointChessman[15].y=7;
	g_pointChessman[16].x=5;g_pointChessman[16].y=1;//
	g_pointChessman[17].x=4;g_pointChessman[17].y=1;//ʿ
	g_pointChessman[18].x=6;g_pointChessman[18].y=1;
	g_pointChessman[19].x=3;g_pointChessman[19].y=1;//
	g_pointChessman[20].x=7;g_pointChessman[20].y=1;
	g_pointChessman[21].x=2;g_pointChessman[21].y=1;//
	g_pointChessman[22].x=8;g_pointChessman[22].y=1;
	g_pointChessman[23].x=1;g_pointChessman[23].y=1;//
	g_pointChessman[24].x=9;g_pointChessman[24].y=1;
	g_pointChessman[25].x=2;g_pointChessman[25].y=3;//
	g_pointChessman[26].x=8;g_pointChessman[26].y=3;
	g_pointChessman[27].x=1;g_pointChessman[27].y=4;//
	g_pointChessman[28].x=3;g_pointChessman[28].y=4;
	g_pointChessman[29].x=5;g_pointChessman[29].y=4;
	g_pointChessman[30].x=7;g_pointChessman[30].y=4;
	g_pointChessman[31].x=9;g_pointChessman[31].y=4;

	g_iSide=RED;

	FixManMap(g_iChessmanMap,g_pointChessman,g_iSide);
	g_pointBoxFrom.x=0;
	g_pointBoxFrom.y=0;
	g_pointBoxTo.x=0;
	g_pointBoxTo.y=0;
	g_iChessmanSelect=32;
	g_iComputerSide=1;
	g_bEndGame=FALSE;
	g_MoveHistory.count=0;

	for(i=0;i<11;i++)
	for(j=0;j<12;j++)
	{
		g_bCanMove[i][j]=FALSE;
	}
}

/******************************************************************
ShowRect:		ػ prect ָ

:
hdc:			豸
prect:			ػָ

ֵ:			
******************************************************************/
void ShowRect(HDC hdc,LPRECT prect)
{
	RECT rc1={0,0,XBW,YBW};
	//ȡҪµ:
	IntersectRect(&rc1,&rc1,prect);
	BitBlt(hdc,rc1.left,rc1.top,rc1.right-rc1.left,rc1.bottom-rc1.top,g_hdcChessboard,rc1.left,rc1.top,SRCCOPY);
	
	int left=(rc1.left)/BWA,top=(rc1.top)/BWA,right=(rc1.right)/BWA,bottom=(rc1.bottom)/BWA;

	for(int i=left;i<=right;i++)
	for(int j=top;j<=bottom;j++)
	{
		if(g_bCanMove[i+1][j+1])
		{
			if(g_iChessmanMap[i+1][j+1]==32)
				DrawIcon(hdc,i*BWA+SW,j*BWA+SW,g_hIconCanMove);
			else
				DrawIcon(hdc,i*BWA+SW,j*BWA+SW,g_hIconAttack);
		}
		if(g_iChessmanMap[i+1][j+1]!=32)
			DrawIcon(hdc,i*BWA+SW,j*BWA+SW,g_hIconChessman[ManToIcon[g_iChessmanMap[i+1][j+1]]]);

		if(g_pointBoxFrom.x==i+1&&g_pointBoxFrom.y==j+1||g_pointBoxTo.x==i+1&&g_pointBoxTo.y==j+1)
			DrawIcon(hdc,i*BWA+SW,j*BWA+SW,g_hIconBox);
		if(g_iChessmanSelect!=32)
		{
			if(g_pointChessman[g_iChessmanSelect].x==i+1&&g_pointChessman[g_iChessmanSelect].y==j+1)
				DrawIcon(hdc,i*BWA+SW,j*BWA+SW,g_hIconSelect);			
		}
	}
}

/******************************************************************
ShowPoint:		ػpointλ

:
hdc:			豸
point:			λ

ֵ:			
******************************************************************/
void ShowPoint(HDC hdc,POINT point)
{
	RECT rect;
	rect.left=(point.x-1)*BWA;
	rect.top=(point.y-1)*BWA;
	rect.right=rect.left+BWA;
	rect.bottom=rect.top+BWA;
	ShowRect(hdc,&rect);
}

/******************************************************************
Think:			߷ݽ

:
hWnd:			ھ

ֵ:			
******************************************************************/
void Think(HWND hWnd)
{
	int i,j;
	POINT tmanposition[32];
	int  tside;
	int tmap[11][12];
	for(i=0;i<32;i++)
	{
		tmanposition[i]=g_pointChessman[i];
	}
	tside=g_iSide;
	for(i=0;i<11;i++)
	for(j=0;j<12;j++)
	{
		tmap[i][j]=g_iChessmanMap[i][j];
	}
	int resultman=32;
	POINT resultpoint={0,0};
	BOOL flag=Think(tmap,tmanposition,tside,resultman,resultpoint);
	if(flag)
	{
		Go(hWnd,resultman,resultpoint);
	}
	else
	{
		g_bEndGame=TRUE;
		MessageBox(hWnd,"Game over!","MantisChess",MB_OK);
	}

}

/******************************************************************
Go:				

:
hWnd:			ھ
man:			ƶ
targetpoint:	Ŀλ

ֵ:			ɹTRUE,򷵻FALSE
******************************************************************/
BOOL Go(HWND hWnd,int man, POINT targetpoint)
{
	int i,j;

	HDC hdc =GetDC(hWnd);
	if(g_bEndGame)return FALSE;
	if(g_MoveHistory.count>=MAXMOVE)g_MoveHistory.count=0;

	if(!CanGo(g_iChessmanMap,man,g_pointChessman[man],targetpoint))return FALSE;
	
	g_MoveHistory.betaken[g_MoveHistory.count]=g_iChessmanMap[targetpoint.x][targetpoint.y];
	g_MoveHistory.man[g_MoveHistory.count]=man;
	g_MoveHistory.from[g_MoveHistory.count]=g_pointChessman[man];
	g_MoveHistory.to[g_MoveHistory.count]=targetpoint;
	g_MoveHistory.count++;

	if(g_iChessmanMap[targetpoint.x][targetpoint.y]!=32)
	{
		g_pointChessman[g_iChessmanMap[targetpoint.x][targetpoint.y]].x=0;
	}

	POINT from,to;

	from=g_pointBoxFrom;
	to=g_pointBoxTo;
	g_pointBoxFrom=g_pointChessman[man];
	g_pointBoxTo=targetpoint;



	POINT oldselect;
	oldselect=g_pointChessman[man];
	g_pointChessman[man]=targetpoint;
	FixManMap(g_iChessmanMap,g_pointChessman,g_iSide);

	g_iChessmanSelect=32;
	g_iSide=!g_iSide;

	
	for(i=0;i<11;i++)
	for(j=0;j<12;j++)
	{
		POINT pt;
		pt.x=i;
		pt.y=j;
		if(CanGo(g_iChessmanMap,man,g_pointChessman[man],pt))
		{
			if(!g_bCanMove[i][j])
			{
				g_bCanMove[i][j]=TRUE;
				ShowPoint(hdc,pt);
			}
		}
		else
		{
			if(g_bCanMove[i][j])
			{
				g_bCanMove[i][j]=FALSE;
				ShowPoint(hdc,pt);
			}
		}
	}

	ShowPoint(hdc,oldselect);
	ShowPoint(hdc,targetpoint);
	ShowPoint(hdc,to);
	ShowPoint(hdc,from);

	if(g_pointChessman[FistOfSide[g_iSide]].x==0)
	{
		::MessageBox(hWnd,"Game over!","MantisChess",MB_OK);
		g_bEndGame=TRUE;
		return TRUE;
	}
	if(g_iComputerSide==g_iSide&&!g_bEndGame)
	{
		SetCursor(g_hCurThinking);
		Think(hWnd);
		SetCursor(g_hCurCantGo);
	}
	return TRUE;
}

/******************************************************************
FaceToPoint:	λתɶӦ

:
point:			λ

ֵ:			λڷTRUE,򷵻FALSE
******************************************************************/
BOOL FaceToPoint(POINT &point)
{
	if((point.x)%BWA<SW||(point.x)%BWA>BWA-SW)return FALSE;
	if((point.y)%BWA<SW||(point.y)%BWA>BWA-SW)return FALSE;
	POINT p;
	p.x=(point.x)/BWA+1;
	p.y=(point.y)/BWA+1;
	if(p.x<1||p.x>9||p.y<1||p.y>10)return FALSE;
	point=p;
	return TRUE;
}

/******************************************************************
OnLButtonDown:	WM_LBUTTONDOWN ϢӦ

:
hWnd:			ھ
point:			

ֵ:			
******************************************************************/
void OnLButtonDown(HWND hWnd,POINT point) 
{
	int i,j;

	if(g_bEndGame)
	{
		MessageBox(hWnd,"Game over!","MantisChess",MB_OK);
	}
	else if(FaceToPoint(point))
	{
		if(SideOfMan[g_iChessmanMap[point.x][point.y]]==!g_iComputerSide)
		{
			HDC hdc=GetDC(hWnd);
			POINT p;
			BOOL flag=FALSE;
			if(g_iChessmanSelect!=32)
			{
				p=g_pointChessman[g_iChessmanSelect];
				flag=TRUE;
			}
			g_iChessmanSelect=g_iChessmanMap[point.x][point.y];

			for(i=0;i<11;i++)
			for(j=0;j<12;j++)
			{
				POINT pt;
				pt.x=i;
				pt.y=j;
				if(CanGo(g_iChessmanMap,g_iChessmanSelect,g_pointChessman[g_iChessmanSelect],pt))
				{
					if(!g_bCanMove[i][j])
					{
						g_bCanMove[i][j]=TRUE;
						ShowPoint(hdc,pt);
					}
				}
				else
				{
					if(g_bCanMove[i][j])
					{
						g_bCanMove[i][j]=FALSE;
						ShowPoint(hdc,pt);
					}
				}
			}

			ShowPoint(hdc,g_pointChessman[g_iChessmanSelect]);
			if(flag)
				ShowPoint(hdc,p);
		}
		else if(g_iChessmanSelect!=32)
		{
			Go(hWnd,g_iChessmanSelect,point);
		}
	}
}

/******************************************************************
OnMouseMove:	WM_MOUSEMOVE ϢӦ

:
point:			

ֵ:			
******************************************************************/
void OnMouseMove(POINT point) 
{
	if(FaceToPoint(point))
	{
		if(g_iChessmanSelect!=32)
		{
			if(CanGo(g_iChessmanMap,g_iChessmanSelect,g_pointChessman[g_iChessmanSelect],point))
			{
				SetCursor(g_hCurHand);
			}
			else
			{
				SetCursor(g_hCurCantGo);
			}
		}
		else
		{
			if(SideOfMan[g_iChessmanMap[point.x][point.y]]==!g_iComputerSide)
			{
				SetCursor(g_hCurHand);
			}
			else
			{
				SetCursor(g_hCurCantGo);
			}
		}
	}
}

/******************************************************************
OnBack:	Back˵Ӧ

:
hWnd:			ھ

ֵ:			
******************************************************************/
void OnBack(HWND hWnd)
{
	int i,j;
	if(g_MoveHistory.count<2) return;
	for( i=g_MoveHistory.count-1;i>=g_MoveHistory.count-2;i--)
	{
		g_pointChessman[g_MoveHistory.man[i]]=g_MoveHistory.from[i];
		g_iChessmanSelect=g_MoveHistory.man[i];
		g_iChessmanMap[g_MoveHistory.from[i].x][g_MoveHistory.from[i].y]=g_MoveHistory.man[i];
		g_pointBoxFrom=g_MoveHistory.from[i];
		if(g_MoveHistory.betaken[i]!=32)
		{
			g_pointChessman[g_MoveHistory.betaken[i]]=g_MoveHistory.to[i];
		}
		g_iChessmanMap[g_MoveHistory.to[i].x][g_MoveHistory.to[i].y]=g_MoveHistory.betaken[i];
		g_pointBoxTo=g_MoveHistory.to[i];
	}
	
	g_MoveHistory.count-=2;
	g_bEndGame=FALSE;
	
	for(i=0;i<11;i++)
	for(j=0;j<12;j++)
	{
		g_bCanMove[i][j]=FALSE;
	}
	
	InvalidateRect(hWnd,NULL,TRUE);
}